/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, fromEnum, markType } from "./type";
import { StockChangedEventArgs } from "./StockChangedEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { FinancialDataGenerator } from "./FinancialDataGenerator";
import { List$1 } from "./List$1";
import { stringIsNullOrEmpty } from "./string";
import { arrayClear } from "./array";
/**
 * @hidden
 */
export class FinancialDataAdapter extends Base {
    constructor() {
        super();
        this.c = new Array(0);
        this.b = new Array(0);
        this.a = new Array(0);
        this.v = 12 * 5;
        this.u = 24;
        this.k = false;
        this.l = true;
        this.propertyChanged = null;
        this.stockSymbolsChanged = null;
        this.r = new Dictionary$2(String_$type, Base.$, 0);
        this.q = new Dictionary$2(String_$type, Base.$, 0);
        this.s = new Dictionary$2(String_$type, String_$type, 0);
        this.h = new FinancialDataGenerator();
    }
    get stockSymbols() {
        return this.c;
    }
    set stockSymbols(a) {
        this.as(this.c, a);
    }
    get stockSources() {
        return this.b;
    }
    set stockSources(a) {
        let b = this.b;
        this.b = a;
        if (b != this.b) {
            this.ag("StockSources", b, this.b);
        }
    }
    get stockPositions() {
        return this.a;
    }
    set stockPositions(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.ag("StockPositions", b, this.a);
        }
    }
    get x() {
        return this.v;
    }
    set x(a) {
        let b = this.v;
        this.v = a;
        if (b != this.v) {
            this.ag("StockHistoryRange", b, this.v);
        }
    }
    get w() {
        return this.u;
    }
    set w(a) {
        let b = this.u;
        this.u = a;
        if (b != this.u) {
            this.ag("StockHistoryInterval", b, this.u);
        }
    }
    get isAutoGeneratingStockData() {
        return this.k;
    }
    set isAutoGeneratingStockData(a) {
        if (this.k != a) {
            this.k = a;
            this.ag("IsAutoGeneratingStockData", !a, a);
        }
    }
    get isAutoReplacingStockSymbols() {
        return this.l;
    }
    set isAutoReplacingStockSymbols(a) {
        if (this.l != a) {
            this.l = a;
            this.ag("IsAutoReplacingStockSymbols", !a, a);
        }
    }
    ag(a, b, c) {
        this.ah(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    ah(a, b, c) {
        switch (a) {
            case "StockHistoryRange":
            case "StockHistoryInterval":
            case "IsAutoGeneratingStockData":
                this.aq();
                break;
            case "StockSymbols":
                this.ap(b, c);
                break;
        }
    }
    am(a, b) {
        if (a == null) {
            a = new Array(0);
        }
        if (b == null) {
            b = new Array(0);
        }
        if (this.stockSymbolsChanged != null) {
            this.stockSymbolsChanged(this, new StockChangedEventArgs(a, b));
        }
    }
    stockClear() {
        this.aj();
    }
    stockAdd(a, b = "") {
        let e = this.stockSymbols;
        for (let d = 0; d < e.length; d++) {
            let c = e[d];
            if (!this.s.containsKey(c)) {
                this.s.addItem(c, "");
            }
        }
        if (this.s.containsKey(a)) {
            this.s.item(a, b);
        }
        else {
            this.s.addItem(a, b);
        }
        let f = this.t(this.stockSymbols);
        if (!f.contains(a)) {
            f.add(a);
        }
        this.stockSymbols = this.d(f);
    }
    stockRemove(a) {
        if (this.r.containsKey(a)) {
            let b = this.t(this.stockSymbols);
            if (this.s.containsKey(a)) {
                this.s.removeItem(a);
            }
            let c = this.t(this.stockSymbols);
            if (c.contains(a)) {
                c.remove(a);
            }
            this.c = this.d(c);
            this.ap(this.d(b), this.d(c));
        }
    }
    y(a) {
        if (stringIsNullOrEmpty(a)) {
            return "";
        }
        if (this.s.containsKey(a)) {
            return this.s.item(a);
        }
        return "";
    }
    i(a) {
        this.h.dateRange = this.x;
        this.h.dateInterval = this.w;
        let b = this.y(a);
        let c = this.h.generatePosition(a, b);
        return c;
    }
    ai(a, b, c, d) {
        if (stringIsNullOrEmpty(a)) {
            return;
        }
        if (d == null) {
            return;
        }
        if (this.r.containsKey(a)) {
            return;
        }
        if (this.q.containsKey(a)) {
            return;
        }
        this.r.addItem(a, c);
        this.q.addItem(a, d);
        this.stockSources = new Array(this.r.values.count);
        let e = 0;
        for (let f of fromEnum(this.r.keys)) {
            this.stockSources[e] = this.r.item(f);
            this.stockPositions[e] = this.q.item(f);
            e++;
        }
    }
    ak(a, b, c, d) {
        if (stringIsNullOrEmpty(a)) {
            return;
        }
        if (!this.r.containsKey(a)) {
            return;
        }
        if (!this.q.containsKey(a)) {
            return;
        }
        this.r.removeItem(a);
        this.q.removeItem(a);
        this.stockSources = new Array(this.r.values.count);
        let e = 0;
        for (let f of fromEnum(this.r.keys)) {
            this.stockSources[e] = this.r.item(f);
            this.stockPositions[e] = this.q.item(f);
            e++;
        }
    }
    al(a, b, c, d) {
        if (d == null) {
            return;
        }
        if (!this.r.containsKey(a)) {
            return;
        }
        if (!this.q.containsKey(a)) {
            return;
        }
        this.r.item(a, c);
        this.q.item(a, d);
        this.stockSources[b] = c;
        this.stockPositions[b] = d;
    }
    aj() {
        this.as(this.stockSymbols, new Array(0), true);
    }
    as(a, b, c = false) {
        if (this.n(a, b)) {
            return;
        }
        if (this.isAutoReplacingStockSymbols || c) {
            this.c = b;
            this.ag("StockSymbols", a, this.c);
            this.am(a, this.c);
        }
        else {
            let d = this.t(a);
            for (let f = 0; f < b.length; f++) {
                let e = b[f];
                if (!d.contains(e)) {
                    d.add(e);
                }
            }
            this.c = this.d(d);
            this.ag("StockSymbols", null, this.c);
            this.am(a, this.c);
        }
    }
    ap(a, b) {
        if (a == b) {
            return;
        }
        if (this.isAutoGeneratingStockData) {
            if (a != null && a.length != 0) {
                for (let c = a.length - 1; c >= 0; c--) {
                    let d = a[c];
                    if (this.r.containsKey(d)) {
                        this.ak(d, c, this.r.item(d), this.q.item(d));
                    }
                }
            }
            if (b != null && b.length != 0) {
                for (let e = 0; e < b.length; e++) {
                    let f = b[e];
                    if (!this.r.containsKey(f)) {
                        let g = this.i(f);
                        this.ai(f, e, g.data, g);
                    }
                }
            }
        }
    }
    aq() {
        this.h.dateRange = this.x;
        this.h.dateInterval = this.w;
        if (this.stockSymbols == null || this.stockSymbols.length == 0) {
            this.r.clear();
            this.q.clear();
            arrayClear(this.stockSources);
            arrayClear(this.stockPositions);
        }
        else if (this.isAutoGeneratingStockData) {
            this.r.clear();
            this.q.clear();
            arrayClear(this.stockSources);
            arrayClear(this.stockPositions);
            for (let a = 0; a < this.stockSymbols.length; a++) {
                let b = this.stockSymbols[a];
                let c = this.i(b);
                this.ai(b, a, c.data, c);
            }
        }
    }
    m(a, b) {
        if (a == null || a.length == 0) {
            return false;
        }
        for (let d = 0; d < a.length; d++) {
            let c = a[d];
            if (b == c) {
                return true;
            }
        }
        return false;
    }
    d(a) {
        if (a == null || a.count == 0) {
            return new Array(0);
        }
        let b = new Array(a.count);
        for (let c = 0; c < a.count; c++) {
            b[c] = a._inner[c];
        }
        return b;
    }
    t(a) {
        if (a == null || a.length == 0) {
            return new List$1(String_$type, 0);
        }
        let b = new List$1(String_$type, 0);
        for (let c = 0; c < a.length; c++) {
            b.add(a[c]);
        }
        return b;
    }
    n(a, b) {
        if (a == null || b == null) {
            return false;
        }
        if (a.length != b.length) {
            return false;
        }
        for (let c = 0; c < a.length; c++) {
            if (a[c] != b[c]) {
                return false;
            }
        }
        return true;
    }
}
FinancialDataAdapter.$t = markType(FinancialDataAdapter, 'FinancialDataAdapter', Base.$, [INotifyPropertyChanged_$type]);
