/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "./type";
/**
 * @hidden
 */
export class FinancialDataPosition extends Base {
    constructor() {
        super(...arguments);
        this._company = null;
        this._symbol = null;
        this._tradeDate = new Date();
        this._shares = 0;
        this._costPerShare = 0;
        this._currentPrice = 0;
        this._data = null;
        this._action = null;
    }
    get company() {
        return this._company;
    }
    set company(a) {
        this._company = a;
    }
    get symbol() {
        return this._symbol;
    }
    set symbol(a) {
        this._symbol = a;
    }
    get tradeDate() {
        return this._tradeDate;
    }
    set tradeDate(a) {
        this._tradeDate = a;
    }
    get shares() {
        return this._shares;
    }
    set shares(a) {
        this._shares = a;
    }
    get costPerShare() {
        return this._costPerShare;
    }
    set costPerShare(a) {
        this._costPerShare = a;
    }
    get costTotal() {
        return this.shares * this.costPerShare;
    }
    get currentValue() {
        return this.shares * this.currentPrice;
    }
    get profit() {
        return this.currentValue - this.costTotal;
    }
    get currentPrice() {
        return this._currentPrice;
    }
    set currentPrice(a) {
        this._currentPrice = a;
    }
    get data() {
        return this._data;
    }
    set data(a) {
        this._data = a;
    }
    get action() {
        return this._action;
    }
    set action(a) {
        this._action = a;
    }
}
FinancialDataPosition.$t = markType(FinancialDataPosition, 'FinancialDataPosition');
