/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
/**
 * @hidden
 */
export class LocalDataSource extends BaseDataSource {
    constructor() {
        super();
        this.b1 = null;
        this.b0 = null;
        this.cu = null;
        this.b6 = null;
        this.ca = null;
        this.cc = null;
        this.b8 = null;
        this.cl = new List$1(Array_$type, 0);
        this.cd = false;
        this.bz = null;
        this.cq = -1;
        this.cm = -1;
        this.cs = -1;
        this.co = -1;
        this.ct = -1;
        this.cp = -1;
        this.cr = -1;
        this.cn = -1;
        this.executionContext = new DataSourceExecutionContext();
    }
    get_actualBaseDataProvider() {
        return this.actualDataProvider;
    }
    get actualBaseDataProvider() {
        return this.get_actualBaseDataProvider();
    }
    get dataProvider() {
        return this.b1;
    }
    set dataProvider(a) {
        let b = this.b1;
        this.b1 = a;
        if (b != this.b1) {
            this.onPropertyUpdated("DataProvider", b, this.b1);
        }
    }
    get actualDataProvider() {
        if (this.b0 == null) {
            this.actualDataProvider = this.resolveDataProvider();
        }
        return this.b0;
    }
    set actualDataProvider(a) {
        let b = this.b0;
        this.b0 = a;
        if (b != this.b0) {
            this.onPropertyUpdated("ActualDataProvider", b, this.b0);
        }
    }
    get itemsSource() {
        return this.cu;
    }
    set itemsSource(a) {
        let b = this.cu;
        this.cu = a;
        if (b != this.cu) {
            this.onPropertyUpdated("ItemsSource", b, this.cu);
        }
    }
    canInitialize() {
        let a = super.canInitialize();
        if (!a) {
            return false;
        }
        return this.itemsSource != null;
    }
    get b7() {
        return this.b6;
    }
    set b7(a) {
        this.b6 = a;
        this.actualDataProvider = this.resolveDataProvider();
    }
    resolveDataProvider() {
        let provider_ = new DataSourceLocalDataProvider();
        provider_.executionContext = new DataSourceExecutionContext();
        return provider_;
    }
    propertyUpdatedOverride(a, b, c) {
        super.propertyUpdatedOverride(a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                break;
            case "ActualDataProvider":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
            case "ItemsSource":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
        }
    }
    getItemAtIndex(a) {
        if (this.ca != null && this.ca.ak != null) {
            return this.ca.ak.item(a);
        }
        else {
            return this.actualDataProvider.getItemAtIndex(a);
        }
    }
    getItemPropertyAtIndex(a, b) {
        let c;
        if (this.ca != null) {
            c = this.ca.ak.item(a);
        }
        else {
            c = this.actualDataProvider.getItemAtIndex(a);
        }
        let item_ = c;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return this.getSpecialRowItemValue(c, b);
        }
        return this.actualDataProvider.getItemValue(c, b);
    }
    b5() {
        return this.actualDataProvider;
    }
    cf() {
        return this.cl != null && this.cl.count > 0;
    }
    refreshInternalOverride() {
        super.refreshInternalOverride();
        if (this.actualDataProvider != null) {
            if (this.cg() || this.ch() || this.ci() || this.cf()) {
                if (this.ca == null) {
                    if (this.cc == null) {
                        this.cc = new LocalDataSourceViewUpdateNotifier(this);
                    }
                    this.ca = new RearrangedListView(this.actualDataProvider);
                    this.ca.n = this.cc;
                }
                this.ensureComparables(this.actualDataProvider.actualSchema);
                this.ca.z = this.shouldEmitSectionHeaders && this.ad;
                this.ca.y = this.shouldEmitSectionFooters && this.ad;
                this.ca.aa = this.shouldEmitShiftedRows;
                this.ca.ba(this.cl);
                this.ca.ag = this.ck();
                this.ca.af = this.cj();
                this.ca.g = this.b9();
                this.ca.o = this.groupDescriptions;
                this.ca.p = this.sortDescriptions;
                this.ca.d = this;
                this.ca.v = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                this.ca.i = this.cb();
                this.ca.a6();
                this.actualSchema = this.actualDataProvider.actualSchema;
                this.actualCount = this.ca.ak.count;
            }
            else {
                let a = this.b5();
                this.actualSchema = this.actualDataProvider.actualSchema;
                if (a != null) {
                    this.actualCount = a.actualCount;
                }
                else {
                    this.actualCount = 0;
                }
                if (this.ca != null) {
                    this.ca.n = null;
                    this.ca = null;
                    this.onBroadcastClearItems();
                }
            }
        }
        else {
            this.actualCount = 0;
            this.actualSchema = null;
        }
    }
    get_isItemIndexLookupSupported() {
        return true;
    }
    get_isKeyIndexLookupSupported() {
        return true;
    }
    indexOfItem(a) {
        if (this.ca != null) {
            return this.ca.ak.indexOf(a);
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        if (this.actualDataProvider != null) {
            let b = this.actualDataProvider.actualCount;
            let c;
            for (let d = 0; d < b; d++) {
                c = this.actualDataProvider.getItemAtIndex(d);
                if (this.ce(c, a)) {
                    return d;
                }
            }
        }
        return -1;
    }
    ce(a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    }
    indexOfKey(a) {
        let b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return this.indexOfItem(a[0]);
        }
        let c = this.b9();
        let d;
        if (this.ca != null) {
            let e = this.ca.ak.count;
            for (let f = 0; f < e; f++) {
                d = this.ca.ak.item(f);
                if (!(typeCast(DataSourceSpecialRow.$, d) !== null) && c.i(d, a) == 0) {
                    return f;
                }
            }
            return -1;
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        if (this.actualDataProvider != null) {
            let g = this.actualDataProvider.actualCount;
            for (let h = 0; h < g; h++) {
                d = this.actualDataProvider.getItemAtIndex(h);
                if (c.i(d, a) == 0) {
                    return h;
                }
            }
        }
        return -1;
    }
    onActualPrimaryKeyChangedOverrride(a, b) {
        super.onActualPrimaryKeyChangedOverrride(a, b);
        this.b8 = null;
    }
    b9() {
        if (this.b8 != null) {
            return this.b8;
        }
        if (this.actualPrimaryKey == null) {
            this.b8 = new DataSourcePropertiesComparer(null, null, null, this);
            return this.b8;
        }
        let a = new Array(this.actualPrimaryKey.length);
        for (let b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        this.b8 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
        return this.b8;
    }
    cb() {
        if (this.filterExpressions.j.count == 0) {
            return null;
        }
        let a = this.actualDataProvider;
        let b = this.actualDataProvider.actualSchema;
        let c = this.filterExpressions.j;
        let d = (e) => {
            for (let f = 0; f < c.count; f++) {
                if (!c.item(f).match(e, a, b)) {
                    return false;
                }
            }
            return true;
        };
        return d;
    }
    ck() {
        let a = 0;
        if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
            return null;
        }
        a = this.sortDescriptions.k.count;
        if (this.groupDescriptions != null) {
            a += this.groupDescriptions.k.count;
        }
        let b = new Array(a);
        let c = new Array(a);
        let d = 0;
        if (this.groupDescriptions != null) {
            for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                b[e] = this.groupDescriptions.k.item(e).propertyName;
                c[e] = this.groupDescriptions.k.item(e).direction;
                d++;
            }
        }
        for (let f = 0; f < this.sortDescriptions.k.count; f++) {
            b[f + d] = this.sortDescriptions.k.item(f).propertyName;
            c[f + d] = this.sortDescriptions.k.item(f).direction;
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    }
    cj() {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return null;
        }
        let a = 0;
        a = this.groupDescriptions.k.count;
        let b = new Array(a);
        let c = new Array(a);
        if (this.groupDescriptions != null) {
            for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                b[d] = this.groupDescriptions.k.item(d).propertyName;
                c[d] = this.groupDescriptions.k.item(d).direction;
            }
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    }
    ch() {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isGroupingSupported) {
            return false;
        }
        return true;
    }
    ci() {
        if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isSortingSupported) {
            return false;
        }
        return true;
    }
    cg() {
        return this.filterExpressions != null && this.filterExpressions.j.count > 0;
    }
    onClearItemsOverride() {
        if (this.ca != null) {
            this.ca.notifyClearItems();
            this.queueAutoRefresh();
        }
        else {
            super.onClearItemsOverride();
        }
    }
    onSetItemOverride(a, b, c) {
        if (this.ca != null) {
            this.ca.notifySetItem(a, b, c);
        }
        else {
            super.onSetItemOverride(a, b, c);
        }
    }
    onInsertItemOverride(a, b) {
        if (this.ca != null) {
            this.ca.notifyInsertItem(a, b);
        }
        else {
            super.onInsertItemOverride(a, b);
        }
    }
    onRemoveItemOverride(a, b) {
        if (this.ca != null) {
            this.ca.notifyRemoveItem(a, b);
        }
        else {
            super.onRemoveItemOverride(a, b);
        }
    }
    cz() {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastClearItems();
    }
    c2(a, b, c) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastSetItem(a, b, c);
    }
    c0(a, b) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastInsertItem(a, b);
    }
    c1(a, b) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastRemoveItem(a, b);
    }
    pinRow(a) {
        super.pinRow(a);
        this.cq = -1;
        this.cm = -1;
        if (this.ca != null) {
            this.cl.add(a);
            this.ca.a5(a);
        }
        else {
            this.cl.add(a);
            this.queueAutoRefresh();
        }
    }
    unpinRow(a) {
        super.unpinRow(a);
        let b = this.b9();
        if (this.ca != null) {
            for (let c = this.cl.count - 1; c >= 0; c--) {
                let d = this.cl._inner[c];
                if (d.length != a.length) {
                    continue;
                }
                if (b.h(d, a) == 0) {
                    this.cl.removeAt(c);
                    this.ca.bc(d);
                }
            }
        }
        else {
            for (let e = this.cl.count - 1; e >= 0; e--) {
                let f = this.cl._inner[e];
                if (f.length != a.length) {
                    continue;
                }
                if (b.h(f, a) == 0) {
                    this.cl.removeAt(e);
                }
            }
            this.queueAutoRefresh();
        }
        this.cq = -1;
        this.cm = -1;
    }
    clearPinnedRows() {
        for (let a = this.cl.count - 1; a >= 0; a--) {
            this.unpinRow(this.cl._inner[a]);
        }
    }
    isRowPinned(a) {
        if (this.ca == null) {
            return false;
        }
        let b = this.getItemAtIndex(a);
        if (b == null) {
            return false;
        }
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            if (item_.rowType == 3) {
                return true;
            }
        }
        let c = this.b9();
        let d;
        if (this.actualPrimaryKey == null) {
            d = new Array(1);
            d[0] = b;
        }
        else {
            let e = this.actualPrimaryKey;
            let f = e.length;
            d = new Array(f);
            for (let g = 0; g < f; g++) {
                d[g] = this.getItemProperty(b, e[g]);
            }
        }
        for (let h = 0; h < this.cl.count; h++) {
            if (c.h(this.cl._inner[h], d) == 0) {
                return true;
            }
        }
        return false;
    }
    get_isSortingSupported() {
        if (this.n != null && !this.cd) {
            this.cd = true;
            let a = this.n.isSortingSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    }
    get_isFilteringSupported() {
        if (this.n != null && !this.cd) {
            this.cd = true;
            let a = this.n.isFilteringSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    }
    get_isGroupingSupported() {
        if (this.n != null && !this.cd) {
            this.cd = true;
            let a = this.n.isGroupingSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    }
    getStickyRowPriority(a) {
        if (this.getRowType(a) == 1 || this.getRowType(a) == 2) {
            return 100 - this.getRowLevel(a);
        }
        else if (this.getRowType(a) == 3) {
            return 2;
        }
        return 1;
    }
    getStickyRowsInRange(a, b) {
        if (this.ca == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && !this.cf())) {
            return null;
        }
        let c = null;
        let d = null;
        if (this.ca.aj.count == 1) {
            c = this.ca.aj._inner[0];
            d = this.ca.aj._inner[0];
        }
        else {
            c = this.ca.k(a);
            d = this.ca.k(b);
        }
        if (c == null || d == null) {
            return null;
        }
        if (c.l == this.cq && c.g == this.cs && c.m == this.ct && c.k == this.cr && d.l == this.cm && d.g == this.co && d.m == this.cp && d.k == this.cn) {
            return this.bz;
        }
        this.cq = c.l;
        this.cm = d.l;
        this.cs = c.g;
        this.co = d.g;
        this.ct = c.m;
        this.cp = d.m;
        this.cr = c.k;
        this.cn = d.k;
        if (this.ca.aj.count == 1) {
            this.cm = d.k;
        }
        let e = 0;
        if (this.shouldEmitSectionHeaders && this.ad) {
            e = 1;
        }
        let f = new List$1(Number_$type, 0);
        for (let g = c.l; g <= d.l; g++) {
            if (this.shouldEmitSectionHeaders && this.ad) {
                for (let h = 0; h < this.ca.aj._inner[g].b.length; h++) {
                    f.add(this.ca.aj._inner[g].m + h);
                    if (!this.ca.aj._inner[g].b[h]) {
                        break;
                    }
                }
            }
            if (this.shouldEmitShiftedRows) {
                let i = this.ca.aj._inner[g].b.length;
                for (let j = 0; j < this.ca.aj._inner[g].g; j++) {
                    f.add(this.ca.aj._inner[g].m + j + i);
                }
            }
            if (this.shouldEmitSectionFooters && this.ad) {
                for (let k = this.ca.aj._inner[g].b.length - 1; k >= 0; k--) {
                    if (!this.ca.aj._inner[g].b[k]) {
                        break;
                    }
                    f.add(this.ca.aj._inner[g].k - k);
                }
            }
        }
        this.bz = f.toArray();
        return this.bz;
    }
    isExclusivelySticky(a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    }
    getRowType(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    }
    setIsRowExpandedAtIndex(a, b) {
        if (this.isSectionCollapsable && this.ca != null && this.ca.ak.count > 0 && this.ca.ak.count > a) {
            this.ca.a9(a, b);
        }
    }
    getIsRowExpandedAtIndex(a) {
        if (this.ca != null && this.ca.ak.count > 0 && this.ca.ak.count > a) {
            return this.ca.t(a);
        }
        return true;
    }
    getRowLevel(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        return 0;
    }
}
LocalDataSource.$t = markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
/**
 * @hidden
 */
export class LocalDataSourceViewUpdateNotifier extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.a = a;
    }
    notifyClearItems() {
        this.a.cz();
    }
    notifyInsertItem(a, b) {
        this.a.c0(a, b);
    }
    notifyRemoveItem(a, b) {
        this.a.c1(a, b);
    }
    notifySetItem(a, b, c) {
        this.a.c2(a, b, c);
    }
}
LocalDataSourceViewUpdateNotifier.$t = markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
