/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
export class VirtualDataSource extends BaseDataSource {
    constructor() {
        super();
        this.b1 = null;
        this.ch = false;
        this.cb = null;
        this.b4 = null;
        this.b3 = null;
        this.cx = 50;
        this.cw = 200;
        this.actualPageSizePopulated = false;
        this.cn = 50;
        this.cf = false;
        this.b8 = null;
        this.ce = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
        this.cl = new Dictionary$2(Base.$, Array_$type, 0);
        this.cm = new Dictionary$2(Number_$type, Number_$type, 0);
        this.cg = false;
        this.bz = null;
        this.cd = new SectionMap();
        this.b0 = null;
        this.cs = -1;
        this.co = -1;
        this.cu = -1;
        this.cq = -1;
        this.cv = -1;
        this.cr = -1;
        this.ct = -1;
        this.cp = -1;
        this.ck = new Dictionary$2(String_$type, Boolean_$type, 0);
        this.cb = new PagePredictionEngine();
        this.cb.e = this;
        this.cb.ag = this.actualPageSize;
        this.cb.f = this.cd;
        this.executionContext = new DataSourceExecutionContext();
        this.cb.b = this.executionContext;
    }
    get_actualBaseDataProvider() {
        return this.actualDataProvider;
    }
    get actualBaseDataProvider() {
        return this.get_actualBaseDataProvider();
    }
    get dataProvider() {
        return this.b4;
    }
    set dataProvider(a) {
        let b = this.b4;
        this.b4 = a;
        if (b != this.b4) {
            this.onPropertyUpdated("DataProvider", b, this.b4);
        }
    }
    get actualDataProvider() {
        if (this.b3 == null) {
            this.actualDataProvider = this.resolveDataProvider();
        }
        return this.b3;
    }
    set actualDataProvider(a) {
        let b = this.b3;
        this.b3 = a;
        if (b != this.b3) {
            this.onPropertyUpdated("ActualDataProvider", b, this.b3);
        }
    }
    get pageSizeRequested() {
        return this.cx;
    }
    set pageSizeRequested(a) {
        let b = this.cx;
        this.cx = a;
        if (b != this.cx) {
            this.onPropertyUpdated("PageSizeRequested", b, this.cx);
        }
    }
    resetCache() {
        if (this.b9 != null) {
            this.b9.resetCache();
        }
        this.resetCacheOverride();
    }
    resetCacheOverride() {
        this.ce.i();
    }
    get maxCachedPages() {
        return this.cw;
    }
    set maxCachedPages(a) {
        let b = this.cw;
        this.cw = a;
        if (b != this.cw) {
            this.onPropertyUpdated("MaxCachedPages", b, this.cw);
        }
    }
    get actualPageSize() {
        return this.cn;
    }
    set actualPageSize(a) {
        let b = this.cn;
        this.cn = a;
        if (b != this.cn) {
            this.onPropertyUpdated("ActualPageSize", b, this.cn);
        }
    }
    get_isSortingSupported() {
        if (this.n != null && !this.cf) {
            this.cf = true;
            let a = this.n.isSortingSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    }
    get_isFilteringSupported() {
        if (this.n != null && !this.cf) {
            this.cf = true;
            let a = this.n.isFilteringSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    }
    get_isGroupingSupported() {
        if (this.n != null && !this.cf) {
            this.cf = true;
            let a = this.n.isGroupingSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    }
    get b9() {
        return this.b8;
    }
    set b9(a) {
        this.b8 = a;
        this.actualDataProvider = this.resolveDataProvider();
    }
    resolveDataProvider() {
        if (this.b9 == null) {
            return null;
        }
        return this.b9.resolveDataProvider();
    }
    propertyUpdatedOverride(a, b, c) {
        super.propertyUpdatedOverride(a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                this.queueAutoRefresh();
                break;
            case "ExecutionContext":
                this.cb.b = this.executionContext;
                break;
            case "ActualDataProvider":
                this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                this.actualDataProvider.pageLoaded = runOn(this, this.dd);
                this.queueAutoRefresh();
                break;
            case "PageSizeRequested":
                this.actualPageSize = this.pageSizeRequested;
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                }
                this.queueAutoRefresh();
                break;
            case "ActualPageSize":
                this.cb.ag = this.actualPageSize;
                this.queueAutoRefresh();
                break;
            case "FirstVisibleIndexRequested":
                this.cb.aa = this.firstVisibleIndexRequested;
                break;
            case "LastVisibleIndexRequested":
                this.cb.ae = this.lastVisibleIndexRequested;
                break;
            case "ActualCount":
                if (this.actualDataProvider != null && !this.cd.n) {
                    this.cb.ab = this.actualDataProvider.actualCount;
                }
                else {
                    this.cb.ab = this.actualCount;
                }
                this.queueAutoRefresh();
                break;
            case "MaxCachedPages":
                this.ce.h = this.maxCachedPages;
                break;
        }
    }
    c0(a) {
        if (this.ad && this.cd.n) {
            let b = this.cc(a);
            if (b == null) {
                b = this.cd.c();
            }
            return a - b.f;
        }
        return a;
    }
    dd(a, b, c) {
        let d = this.executionContext;
        if (d != null) {
            d.execute(() => this.dj(a, b, c));
        }
        else {
            this.dj(a, b, c);
        }
    }
    dj(a, b, c) {
        if (a == null) {
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            return;
        }
        if (c != this.actualPageSize && !this.actualPageSizePopulated) {
            this.actualPageSize = c;
        }
        this.actualPageSizePopulated = true;
        let d = a.pageIndex();
        this.de(d);
        this.ce.item(d, a);
        let e = a.schema();
        if (e != null) {
            this.actualSchema = e;
        }
        let f = a.getGroupInformation();
        if (this.bz == null && f != null) {
            this.bz = f;
            this.di();
            this.ch = false;
        }
        b = this.resolveFullCount(b);
        if (this.actualCount != b) {
            this.actualCount = b;
        }
        this.dh(a);
    }
    resolveFullCount(a) {
        if (this.bz != null) {
            return this.cd.q;
        }
        return a;
    }
    di() {
        let a = 0;
        let b = 0;
        let c = 0;
        if (this.shouldEmitSectionHeaders) {
            switch (this.sectionHeaderDisplayMode) {
                case 0:
                    c++;
                    break;
                case 1:
                    c += this.groupDescriptions.k.count;
                    break;
            }
        }
        if (this.shouldEmitSectionFooters) {
            c++;
        }
        let d = this.shouldEmitSectionHeaders;
        let e = this.shouldEmitSectionFooters;
        for (let f = 0; f < this.bz.length; f++) {
            let g = new SectionData();
            if (d) {
                switch (this.sectionHeaderDisplayMode) {
                    case 0:
                        b++;
                        break;
                    case 1:
                        b += this.groupDescriptions.k.count;
                        break;
                }
            }
            let h = this.bz[f].endIndex - this.bz[f].startIndex;
            g.m = a;
            g.l = f;
            g.j = h + 1;
            g.k = a + h;
            g.k += c;
            g.f = b;
            g.c = this.bz[f].groupKeyProperties;
            g.d = this.bz[f].groupKeyValues;
            g.n(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
            if (e) {
                b++;
            }
            for (let i = 0; i < g.b.length; i++) {
                let j = this.c9(g, i);
                g.a[i] = j;
                if (this.ck.containsKey(j)) {
                    g.b[i] = this.ck.item(j);
                }
                else {
                    g.b[i] = this.isSectionExpandedDefault;
                }
                if (!g.b[i]) {
                    let k = g.b.length - 1 - i;
                    g.k -= k;
                    b -= k;
                    if (e) {
                        b--;
                    }
                    i += k;
                }
            }
            if (!g.e) {
                g.k -= g.j;
                b -= g.j;
            }
            a = g.k + 1;
            this.cd.p.add(g);
        }
    }
    dh(a) {
        if (this.updateNotifier != null) {
            let b = a.pageIndex() * this.actualPageSize;
            if (this.actualDataProvider != null) {
                if (b > this.actualDataProvider.actualCount) {
                    return;
                }
            }
            let c = this.cz(b);
            let d = this.cz(b + a.count() - 1);
            if (c > 0 && this.getRowType(c - 1) == 1) {
                c--;
            }
            if (this.actualCount == 0 && a.count() == 0) {
                this.onClearItems();
            }
            else {
                this.updateNotifier.rangeActualized(c, d);
            }
        }
    }
    cz(a) {
        if (this.ad && this.cd.n) {
            let b = this.cd.f(a);
            if (b == null) {
                b = this.cd.c();
            }
            if (!b.e) {
                return b.m;
            }
            return a + b.f;
        }
        return a;
    }
    df(a) {
        a();
    }
    get_isVirtual() {
        return true;
    }
    isPlaceholderItem(a) {
        let b = this.b2(a);
        let c = b[0];
        if (!this.ce.d(c)) {
            return true;
        }
        return false;
    }
    getItemAtIndex(a) {
        let b = this.b2(a);
        let c = b[0];
        if (!this.ce.d(c)) {
            if (b[1] == -1) {
                return this.c4(a);
            }
            return null;
        }
        let d = this.ce.item(c);
        let e = b[1];
        if (e == -1) {
            return this.c4(a);
        }
        return d.getItemAtIndex(e);
    }
    c4(a) {
        let b = this.cc(a);
        if (a >= b.m && a < b.m + b.b.length) {
            let c = a - b.m;
            let d = new DataSourceSpecialRow();
            d.rowType = 1;
            d.level = c;
            if (this.sectionHeaderDisplayMode == 0) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    d.setSectionValue(this.groupDescriptions.k.item(e).propertyName, b.d[e]);
                }
            }
            else {
                d.setSectionValue(this.groupDescriptions.k.item(c).propertyName, b.d[c]);
            }
            return d;
        }
        if (a == b.k) {
            let f = new DataSourceSpecialRow();
            f.rowType = 2;
            for (let g = 0; g < this.groupDescriptions.k.count; g++) {
                f.setSectionValue(this.groupDescriptions.k.item(g).propertyName, b.d[g]);
            }
            return f;
        }
        return null;
    }
    b2(a) {
        if (this.ad && this.cd.n) {
            let b = this.cc(a);
            if (b == null) {
                b = this.cd.c();
            }
            let c = b.m;
            let d = false;
            if (a >= c && a < c + b.b.length && this.shouldEmitSectionHeaders) {
                d = true;
            }
            if (a - (c + b.b.length - 1) <= b.g) {
                d = true;
            }
            let e = a - b.f;
            let f = truncate(Math.floor(e / this.actualPageSize));
            let g = e % this.actualPageSize;
            if (d) {
                g = -1;
            }
            let h = new Array(2);
            h[0] = f;
            h[1] = g;
            return h;
        }
        else {
            let i = truncate(Math.floor(a / this.actualPageSize));
            let j = a % this.actualPageSize;
            let k = new Array(2);
            k[0] = i;
            k[1] = j;
            return k;
        }
    }
    cc(a) {
        return this.cd.d(a);
    }
    getItemPropertyAtIndex(a, b) {
        let c = this.b2(a);
        let d = c[0];
        if (!this.ce.d(d)) {
            if (c[1] == -1) {
                return this.c5(a, b);
            }
            return null;
        }
        let e = this.ce.item(d);
        let f = c[1];
        if (f == -1) {
            return this.c5(a, b);
        }
        return e.getItemValueAtIndex(f, b);
    }
    c5(a, b) {
        let c = this.c4(a);
        if (typeCast(DataSourceSpecialRow.$, c) !== null) {
            return c.getValue(b);
        }
        return null;
    }
    dg(a) {
        if (!this.cm.containsKey(a)) {
            this.cm.addItem(a, 1);
        }
        else {
            this.cm.item(a, this.cm.item(a) + 1);
        }
    }
    de(a) {
        if (this.cm.containsKey(a)) {
            this.cm.item(a, this.cm.item(a) - 1);
            if (this.cm.item(a) <= 0) {
                this.cm.removeItem(a);
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.removePageRequest(a);
                }
            }
        }
    }
    addCandidate(a, b) {
        let c = false;
        if (!this.cl.containsKey(a)) {
            let d = new List$1(Number_$type, 0);
            let e = this.transformPage(a);
            for (let f = 0; f < e.length; f++) {
                let g = e[f];
                if (!this.ce.d(g)) {
                    d.add(g);
                    this.dg(g);
                    let h = this.cm.item(g);
                    if (h == 1 && this.actualDataProvider != null) {
                        this.actualDataProvider.addPageRequest(g, b);
                    }
                    c = true;
                }
            }
            if (d.count > 0) {
                this.cl.addItem(a, d.toArray());
            }
        }
        return c;
    }
    removeCandidate(a) {
        if (this.cl.containsKey(a)) {
            for (let b = 0; b < this.cl.item(a).length; b++) {
                let c = this.cl.item(a)[b];
                this.de(c);
            }
            this.cl.removeItem(a);
        }
    }
    transformPage(a) {
        let b = [a];
        if (this.ad && this.cd.n) {
            let c = a * this.actualPageSize;
            let d = c + this.actualPageSize - 1;
            let e = this.cc(c);
            let f = new List$1(Number_$type, 0);
            for (let g = c; g <= d; g++) {
                if (e == null) {
                    break;
                }
                if (g > e.k) {
                    if (e.l < this.cd.p.count - 1) {
                        e = this.cd.p._inner[e.l + 1];
                    }
                    else {
                        break;
                    }
                }
                if (!e.e || (g >= e.m && g <= e.m + (e.b.length - 1) + e.g)) {
                    continue;
                }
                let h = g - e.f;
                let i = intDivide(h, this.actualPageSize);
                if (!f.contains(i)) {
                    f.add(i);
                }
            }
            b = f.toArray();
        }
        return b;
    }
    getUnrealizedCount() {
        let a = this.ce.g * this.actualPageSize;
        let b = this.actualCount - a;
        return b;
    }
    onSetItemOverride(a, b, c) {
        super.onSetItemOverride(a, b, c);
        let d = this.b2(a);
        let e = d[0];
        if (this.ce.d(e)) {
            this.ce.j(e);
        }
    }
    refreshInternalOverride() {
        super.refreshInternalOverride();
        this.actualPageSizePopulated = false;
        let a = this.actualCount != 0;
        this.cg = true;
        if (!this.ch) {
            this.resetCache();
            if (a) {
                this.onClearItems();
            }
            this.bz = null;
            this.cd.r();
        }
        else {
            this.ch = false;
            if (a) {
                this.onClearItems();
            }
        }
        this.dk();
        this.cb.au();
        this.cg = false;
    }
    dk() {
        if (this.actualDataProvider != null) {
            for (let a of fromEnum(this.cl.values)) {
                for (let c = 0; c < a.length; c++) {
                    let b = a[c];
                    this.actualDataProvider.addPageRequest(b, 1);
                }
            }
        }
    }
    onClearItemsOverride() {
        super.onClearItemsOverride();
        if (!this.cg) {
            this.queueAutoRefresh();
        }
    }
    onInsertItemOverride(a, b) {
        super.onInsertItemOverride(a, b);
        this.queueAutoRefresh();
    }
    onRemoveItemOverride(a, b) {
        super.onRemoveItemOverride(a, b);
        this.queueAutoRefresh();
    }
    get_isItemIndexLookupSupported() {
        return true;
    }
    get_isKeyIndexLookupSupported() {
        return true;
    }
    indexOfItem(a) {
        let b = this.ce.b;
        let c = b.o;
        let d = b.q;
        let e = d.count;
        let f = b.p;
        for (let g = 0; g < e; g++) {
            if (f._inner[g]) {
                continue;
            }
            let h = d._inner[g].b;
            let i = h.count();
            for (let j = 0; j < i; j++) {
                if (this.cj(h.getItemAtIndex(j), a)) {
                    let k = typeGetValue(c._inner[g]);
                    let l = k * this.actualPageSize;
                    return l + j;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        return -1;
    }
    cj(a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    }
    indexOfKey(a) {
        let b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return -1;
        }
        this.ensureComparables(this.actualSchema);
        let c = this.ca();
        let d = this.ce.b;
        let e = d.o;
        let f = d.q;
        let g = f.count;
        let h = d.p;
        for (let i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            let j = f._inner[i].b;
            let k = j.count();
            for (let l = 0; l < k; l++) {
                if (c.i(j.getItemAtIndex(l), a) == 0) {
                    let m = typeGetValue(e._inner[i]);
                    let n = m * this.actualPageSize;
                    return n + l;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        return -1;
    }
    ca() {
        let a = new Array(this.actualPrimaryKey.length);
        for (let b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.b1, this);
    }
    getStickyRowPriority(a) {
        if (this.getRowType(a) == 1 || this.getRowType(a) == 2) {
            return 100 - this.getRowLevel(a);
        }
        else if (this.getRowType(a) == 3) {
            return 2;
        }
        return 1;
    }
    unpinRow(a) {
        super.unpinRow(a);
    }
    pinRow(a) {
        super.pinRow(a);
    }
    isRowPinned(a) {
        return super.isRowPinned(a);
    }
    getStickyRowsInRange(a, b) {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count == 0) {
            return null;
        }
        let c = this.cc(a);
        let d = this.cc(b);
        if (c == null || d == null) {
            return null;
        }
        if (c.l == this.cs && c.g == this.cu && c.m == this.cv && c.k == this.ct && d.l == this.co && d.g == this.cq && d.m == this.cr && d.k == this.cp) {
            return this.b0;
        }
        this.cs = c.l;
        this.co = d.l;
        this.cu = c.g;
        this.cq = d.g;
        this.cv = c.m;
        this.cr = d.m;
        this.ct = c.k;
        this.cp = d.k;
        let e = new List$1(Number_$type, 0);
        for (let f = c.l; f <= d.l; f++) {
            let g = this.cd.p._inner[f];
            if (this.shouldEmitSectionHeaders && this.ad) {
                for (let h = 0; h < g.b.length; h++) {
                    e.add(g.m + h);
                    if (!g.b[h]) {
                        break;
                    }
                }
            }
            if (this.shouldEmitShiftedRows) {
                let i = g.b.length;
                for (let j = 0; j < g.g; j++) {
                    e.add(g.m + j + i);
                }
            }
            if (this.shouldEmitSectionFooters && this.ad) {
                for (let k = g.b.length - 1; k >= 0; k--) {
                    if (!g.b[k]) {
                        break;
                    }
                    e.add(g.k - k);
                }
            }
        }
        this.b0 = e.toArray();
        return this.b0;
    }
    isExclusivelySticky(a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    }
    getRowType(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    }
    getIsRowExpandedAtIndex(a) {
        let b = this.cd.d(a);
        if (b == null) {
            b = this.cd.c();
        }
        for (let c = 0; c < b.b.length; c++) {
            if (a == b.m + c) {
                return b.b[c];
            }
        }
        return super.getIsRowExpandedAtIndex(a);
    }
    setIsRowExpandedAtIndex(a, b) {
        let c = this.cd.d(a);
        if (c == null) {
            c = this.cd.c();
        }
        for (let d = 0; d < c.b.length; d++) {
            if (a == c.m + d) {
                let e = false;
                let f = c.a[d];
                if (this.ck.containsKey(f) && this.ck.item(f) != b) {
                    if (b == this.isSectionExpandedDefault) {
                        this.ck.removeItem(f);
                    }
                    else {
                        this.ck.item(f, b);
                    }
                    e = true;
                }
                else if (b != this.isSectionExpandedDefault) {
                    this.ck.addItem(f, b);
                    e = true;
                }
                if (e) {
                    this.cd.r();
                    this.di();
                    this.ch = true;
                    this.actualCount = this.cd.q;
                }
                break;
            }
        }
    }
    getRowLevel(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        return 0;
    }
    c8(a) {
        let b = "";
        for (let c = 0; c < a.c.length; c++) {
            b += a.c[c] + ":" + a.d[c];
        }
        return b;
    }
    c9(a, b) {
        if (this.sectionHeaderDisplayMode == 0) {
            return this.c8(a);
        }
        let c = "";
        for (let d = 0; d < a.c.length; d++) {
            c += a.c[d] + ":" + a.d[d] + ":";
        }
        c += b;
        return c;
    }
}
VirtualDataSource.$t = markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
