/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, fromEnum, markType } from "./type";
import { StockChangedEventArgs } from "./StockChangedEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { FinancialDataGenerator } from "./FinancialDataGenerator";
import { List$1 } from "./List$1";
import { stringIsNullOrEmpty } from "./string";
import { arrayClear } from "./array";
/**
 * @hidden
 */
var FinancialDataAdapter = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialDataAdapter, _super);
    function FinancialDataAdapter() {
        var _this = _super.call(this) || this;
        _this.c = new Array(0);
        _this.b = new Array(0);
        _this.a = new Array(0);
        _this.v = 12 * 5;
        _this.u = 24;
        _this.k = false;
        _this.l = true;
        _this.propertyChanged = null;
        _this.stockSymbolsChanged = null;
        _this.r = new Dictionary$2(String_$type, Base.$, 0);
        _this.q = new Dictionary$2(String_$type, Base.$, 0);
        _this.s = new Dictionary$2(String_$type, String_$type, 0);
        _this.h = new FinancialDataGenerator();
        return _this;
    }
    Object.defineProperty(FinancialDataAdapter.prototype, "stockSymbols", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.as(this.c, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "stockSources", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ag("StockSources", b, this.b);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "stockPositions", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ag("StockPositions", b, this.a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "x", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            var b = this.v;
            this.v = a;
            if (b != this.v) {
                this.ag("StockHistoryRange", b, this.v);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "w", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (b != this.u) {
                this.ag("StockHistoryInterval", b, this.u);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "isAutoGeneratingStockData", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            if (this.k != a) {
                this.k = a;
                this.ag("IsAutoGeneratingStockData", !a, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataAdapter.prototype, "isAutoReplacingStockSymbols", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            if (this.l != a) {
                this.l = a;
                this.ag("IsAutoReplacingStockSymbols", !a, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialDataAdapter.prototype.ag = function (a, b, c) {
        this.ah(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    FinancialDataAdapter.prototype.ah = function (a, b, c) {
        switch (a) {
            case "StockHistoryRange":
            case "StockHistoryInterval":
            case "IsAutoGeneratingStockData":
                this.aq();
                break;
            case "StockSymbols":
                this.ap(b, c);
                break;
        }
    };
    FinancialDataAdapter.prototype.am = function (a, b) {
        if (a == null) {
            a = new Array(0);
        }
        if (b == null) {
            b = new Array(0);
        }
        if (this.stockSymbolsChanged != null) {
            this.stockSymbolsChanged(this, new StockChangedEventArgs(a, b));
        }
    };
    FinancialDataAdapter.prototype.stockClear = function () {
        this.aj();
    };
    FinancialDataAdapter.prototype.stockAdd = function (a, b) {
        if (b === void 0) { b = ""; }
        var e = this.stockSymbols;
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (!this.s.containsKey(c)) {
                this.s.addItem(c, "");
            }
        }
        if (this.s.containsKey(a)) {
            this.s.item(a, b);
        }
        else {
            this.s.addItem(a, b);
        }
        var f = this.t(this.stockSymbols);
        if (!f.contains(a)) {
            f.add(a);
        }
        this.stockSymbols = this.d(f);
    };
    FinancialDataAdapter.prototype.stockRemove = function (a) {
        if (this.r.containsKey(a)) {
            var b = this.t(this.stockSymbols);
            if (this.s.containsKey(a)) {
                this.s.removeItem(a);
            }
            var c = this.t(this.stockSymbols);
            if (c.contains(a)) {
                c.remove(a);
            }
            this.c = this.d(c);
            this.ap(this.d(b), this.d(c));
        }
    };
    FinancialDataAdapter.prototype.y = function (a) {
        if (stringIsNullOrEmpty(a)) {
            return "";
        }
        if (this.s.containsKey(a)) {
            return this.s.item(a);
        }
        return "";
    };
    FinancialDataAdapter.prototype.i = function (a) {
        this.h.dateRange = this.x;
        this.h.dateInterval = this.w;
        var b = this.y(a);
        var c = this.h.generatePosition(a, b);
        return c;
    };
    FinancialDataAdapter.prototype.ai = function (a, b, c, d) {
        var e_1, _a;
        if (stringIsNullOrEmpty(a)) {
            return;
        }
        if (d == null) {
            return;
        }
        if (this.r.containsKey(a)) {
            return;
        }
        if (this.q.containsKey(a)) {
            return;
        }
        this.r.addItem(a, c);
        this.q.addItem(a, d);
        this.stockSources = new Array(this.r.values.count);
        var e = 0;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.r.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                this.stockSources[e] = this.r.item(f);
                this.stockPositions[e] = this.q.item(f);
                e++;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    FinancialDataAdapter.prototype.ak = function (a, b, c, d) {
        var e_2, _a;
        if (stringIsNullOrEmpty(a)) {
            return;
        }
        if (!this.r.containsKey(a)) {
            return;
        }
        if (!this.q.containsKey(a)) {
            return;
        }
        this.r.removeItem(a);
        this.q.removeItem(a);
        this.stockSources = new Array(this.r.values.count);
        var e = 0;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.r.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                this.stockSources[e] = this.r.item(f);
                this.stockPositions[e] = this.q.item(f);
                e++;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    FinancialDataAdapter.prototype.al = function (a, b, c, d) {
        if (d == null) {
            return;
        }
        if (!this.r.containsKey(a)) {
            return;
        }
        if (!this.q.containsKey(a)) {
            return;
        }
        this.r.item(a, c);
        this.q.item(a, d);
        this.stockSources[b] = c;
        this.stockPositions[b] = d;
    };
    FinancialDataAdapter.prototype.aj = function () {
        this.as(this.stockSymbols, new Array(0), true);
    };
    FinancialDataAdapter.prototype.as = function (a, b, c) {
        if (c === void 0) { c = false; }
        if (this.n(a, b)) {
            return;
        }
        if (this.isAutoReplacingStockSymbols || c) {
            this.c = b;
            this.ag("StockSymbols", a, this.c);
            this.am(a, this.c);
        }
        else {
            var d = this.t(a);
            for (var f = 0; f < b.length; f++) {
                var e = b[f];
                if (!d.contains(e)) {
                    d.add(e);
                }
            }
            this.c = this.d(d);
            this.ag("StockSymbols", null, this.c);
            this.am(a, this.c);
        }
    };
    FinancialDataAdapter.prototype.ap = function (a, b) {
        if (a == b) {
            return;
        }
        if (this.isAutoGeneratingStockData) {
            if (a != null && a.length != 0) {
                for (var c = a.length - 1; c >= 0; c--) {
                    var d = a[c];
                    if (this.r.containsKey(d)) {
                        this.ak(d, c, this.r.item(d), this.q.item(d));
                    }
                }
            }
            if (b != null && b.length != 0) {
                for (var e = 0; e < b.length; e++) {
                    var f = b[e];
                    if (!this.r.containsKey(f)) {
                        var g = this.i(f);
                        this.ai(f, e, g.data, g);
                    }
                }
            }
        }
    };
    FinancialDataAdapter.prototype.aq = function () {
        this.h.dateRange = this.x;
        this.h.dateInterval = this.w;
        if (this.stockSymbols == null || this.stockSymbols.length == 0) {
            this.r.clear();
            this.q.clear();
            arrayClear(this.stockSources);
            arrayClear(this.stockPositions);
        }
        else if (this.isAutoGeneratingStockData) {
            this.r.clear();
            this.q.clear();
            arrayClear(this.stockSources);
            arrayClear(this.stockPositions);
            for (var a = 0; a < this.stockSymbols.length; a++) {
                var b = this.stockSymbols[a];
                var c = this.i(b);
                this.ai(b, a, c.data, c);
            }
        }
    };
    FinancialDataAdapter.prototype.m = function (a, b) {
        if (a == null || a.length == 0) {
            return false;
        }
        for (var d = 0; d < a.length; d++) {
            var c = a[d];
            if (b == c) {
                return true;
            }
        }
        return false;
    };
    FinancialDataAdapter.prototype.d = function (a) {
        if (a == null || a.count == 0) {
            return new Array(0);
        }
        var b = new Array(a.count);
        for (var c = 0; c < a.count; c++) {
            b[c] = a._inner[c];
        }
        return b;
    };
    FinancialDataAdapter.prototype.t = function (a) {
        if (a == null || a.length == 0) {
            return new List$1(String_$type, 0);
        }
        var b = new List$1(String_$type, 0);
        for (var c = 0; c < a.length; c++) {
            b.add(a[c]);
        }
        return b;
    };
    FinancialDataAdapter.prototype.n = function (a, b) {
        if (a == null || b == null) {
            return false;
        }
        if (a.length != b.length) {
            return false;
        }
        for (var c = 0; c < a.length; c++) {
            if (a[c] != b[c]) {
                return false;
            }
        }
        return true;
    };
    FinancialDataAdapter.$t = markType(FinancialDataAdapter, 'FinancialDataAdapter', Base.$, [INotifyPropertyChanged_$type]);
    return FinancialDataAdapter;
}(Base));
export { FinancialDataAdapter };
