/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType } from "./type";
import { Random } from "./Random";
import { FinancialDataPosition } from "./FinancialDataPosition";
import { FinancialDataSource } from "./FinancialDataSource";
import { FinancialDataItem } from "./FinancialDataItem";
import { FinancialDataLookup } from "./FinancialDataLookup";
import { truncate } from "./number";
import { dateNow, dateFromValues, dateGetMonth, dateAddMonths, dateAddHours, dateGetTimeOfDay } from "./date";
import { timeSpanTotalHours, timeSpanInit1 } from "./timespan";
import { stringIsNullOrEmpty } from "./string";
import { round10N } from "./numberExtended";
/**
 * @hidden
 */
var FinancialDataGenerator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialDataGenerator, _super);
    function FinancialDataGenerator() {
        var _this = _super.call(this) || this;
        _this._priceStart = 0;
        _this._priceRange = 0;
        _this._priceMinimum = 0;
        _this._priceMaximum = 0;
        _this._volumeStart = 0;
        _this._volumeRange = 0;
        _this._dateRange = 0;
        _this._dateInterval = 0;
        _this._stockInterval = 0;
        _this._useAfterHours = false;
        _this.f = new Date();
        _this.g = new Date();
        _this.p = new Random(0);
        _this.useAfterHours = true;
        _this.priceStart = 0;
        _this.priceRange = NaN;
        _this.priceMinimum = NaN;
        _this.priceMaximum = NaN;
        _this.volumeStart = 0;
        _this.volumeRange = NaN;
        _this.dateRange = 12;
        _this.dateInterval = 24;
        return _this;
    }
    Object.defineProperty(FinancialDataGenerator.prototype, "priceStart", {
        get: function () {
            return this._priceStart;
        },
        set: function (a) {
            this._priceStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "priceRange", {
        get: function () {
            return this._priceRange;
        },
        set: function (a) {
            this._priceRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "priceMinimum", {
        get: function () {
            return this._priceMinimum;
        },
        set: function (a) {
            this._priceMinimum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "priceMaximum", {
        get: function () {
            return this._priceMaximum;
        },
        set: function (a) {
            this._priceMaximum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "volumeStart", {
        get: function () {
            return this._volumeStart;
        },
        set: function (a) {
            this._volumeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "volumeRange", {
        get: function () {
            return this._volumeRange;
        },
        set: function (a) {
            this._volumeRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "dateRange", {
        get: function () {
            return this._dateRange;
        },
        set: function (a) {
            this._dateRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "dateInterval", {
        get: function () {
            return this._dateInterval;
        },
        set: function (a) {
            this._dateInterval = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "stockInterval", {
        get: function () {
            return this._stockInterval;
        },
        set: function (a) {
            this._stockInterval = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialDataGenerator.prototype, "useAfterHours", {
        get: function () {
            return this._useAfterHours;
        },
        set: function (a) {
            this._useAfterHours = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialDataGenerator.prototype.generatePosition = function (a, b) {
        if (b === void 0) { b = ""; }
        var c = this.generateData(a, b);
        var d = this.p.next2(truncate((c.count * 0.5)), truncate((c.count * 0.75)));
        var e = c._inner[d];
        var f = c._inner[c.count - 1];
        var g = new FinancialDataPosition();
        g.symbol = f.symbol;
        g.company = f.company;
        g.data = c;
        g.tradeDate = e.date;
        g.shares = this.p.next2(100, 900);
        g.costPerShare = e.close;
        g.currentPrice = f.close;
        return g;
    };
    FinancialDataGenerator.prototype.generateData = function (a, b) {
        if (b === void 0) { b = ""; }
        var c = dateNow();
        this.f = dateFromValues(c.getFullYear(), dateGetMonth(c), c.getDate(), 16, 30, 0, 0);
        this.g = dateAddMonths(this.f, -this.dateRange);
        var d = Math.ceil(timeSpanTotalHours((+(this.f) - +(this.g))) / this.dateInterval);
        var e = dateAddHours(this.f, -d * this.dateInterval);
        if (this.g.getTime() > e.getTime()) {
            this.g = e;
        }
        var f = FinancialDataLookup.get(a);
        f.date = this.g;
        if (this.priceStart > 0) {
            f.open = this.priceStart;
        }
        if (this.volumeStart > 0) {
            f.volume = this.volumeStart;
        }
        this.volumeRange = f.volume * 0.1;
        this.priceRange = f.open * 0.05;
        this.priceMinimum = f.open - (f.open * 0.2);
        this.priceMaximum = f.open + (f.open * 0.2);
        f.high = f.open + (f.open * 0.02);
        f.low = f.open - (f.open * 0.02);
        f.close = f.open + ((this.p.nextDouble() - 0.5) * this.priceRange);
        var g = new FinancialDataSource();
        g.symbol = a;
        if (!stringIsNullOrEmpty(b)) {
            f.company = b;
            g.company = b;
        }
        else if (!stringIsNullOrEmpty(f.company)) {
            g.company = f.company;
        }
        else {
        }
        do {
            if (this.useAfterHours || !this.d(f.date)) {
                g.add(f);
            }
            f = this.generateItem(f);
        } while (f.date.getTime() < this.f.getTime());
        return g;
    };
    FinancialDataGenerator.prototype.d = function (a) {
        if (a.getDay() == 6) {
            return true;
        }
        if (a.getDay() == 0) {
            return true;
        }
        var b = timeSpanInit1(9, 30, 0);
        var c = timeSpanInit1(16, 30, 0);
        var d = dateGetTimeOfDay(a);
        if (d < b || d > c) {
            return true;
        }
        return false;
    };
    FinancialDataGenerator.prototype.generateItem = function (a) {
        var _this = this;
        var b = (this.p.nextDouble() - 0.49) * this.priceRange;
        var c = a.close;
        var d = a.close + b;
        if (d < this.priceMinimum) {
            d = this.priceMinimum + b;
        }
        if (d > this.priceMaximum) {
            d = this.priceMaximum - b;
        }
        var e = (this.p.nextDouble() * 1.5 * Math.abs(b));
        var f = (this.p.nextDouble() * 1.5 * Math.abs(b));
        if (d > c) {
            e = d + e;
            f = c - f;
        }
        else {
            e = c + e;
            f = d - f;
        }
        var g = (this.p.nextDouble() - 0.49) * this.volumeRange;
        var h = truncate(Math.abs(a.volume + g));
        var i = dateAddHours(a.date, this.dateInterval);
        if (i.getTime() > this.f.getTime()) {
            i = this.f;
        }
        var j = ((function () {
            var $ret = new FinancialDataItem(0);
            $ret.date = dateAddHours(a.date, _this.dateInterval);
            $ret.symbol = a.symbol;
            $ret.company = a.company;
            $ret.close = round10N(d, 2);
            $ret.open = round10N(c, 2);
            $ret.high = round10N(e, 2);
            $ret.low = round10N(f, 2);
            $ret.volume = h;
            return $ret;
        })());
        return j;
    };
    FinancialDataGenerator.$t = markType(FinancialDataGenerator, 'FinancialDataGenerator');
    return FinancialDataGenerator;
}(Base));
export { FinancialDataGenerator };
