/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
/**
 * @hidden
 */
var LocalDataSource = /** @class */ (function (_super) {
    tslib_1.__extends(LocalDataSource, _super);
    function LocalDataSource() {
        var _this = _super.call(this) || this;
        _this.b1 = null;
        _this.b0 = null;
        _this.cu = null;
        _this.b6 = null;
        _this.ca = null;
        _this.cc = null;
        _this.b8 = null;
        _this.cl = new List$1(Array_$type, 0);
        _this.cd = false;
        _this.bz = null;
        _this.cq = -1;
        _this.cm = -1;
        _this.cs = -1;
        _this.co = -1;
        _this.ct = -1;
        _this.cp = -1;
        _this.cr = -1;
        _this.cn = -1;
        _this.executionContext = new DataSourceExecutionContext();
        return _this;
    }
    LocalDataSource.prototype.get_actualBaseDataProvider = function () {
        return this.actualDataProvider;
    };
    Object.defineProperty(LocalDataSource.prototype, "actualBaseDataProvider", {
        get: function () {
            return this.get_actualBaseDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "dataProvider", {
        get: function () {
            return this.b1;
        },
        set: function (a) {
            var b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.onPropertyUpdated("DataProvider", b, this.b1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "actualDataProvider", {
        get: function () {
            if (this.b0 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.onPropertyUpdated("ActualDataProvider", b, this.b0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "itemsSource", {
        get: function () {
            return this.cu;
        },
        set: function (a) {
            var b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.onPropertyUpdated("ItemsSource", b, this.cu);
            }
        },
        enumerable: true,
        configurable: true
    });
    LocalDataSource.prototype.canInitialize = function () {
        var a = _super.prototype.canInitialize.call(this);
        if (!a) {
            return false;
        }
        return this.itemsSource != null;
    };
    Object.defineProperty(LocalDataSource.prototype, "b7", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            this.b6 = a;
            this.actualDataProvider = this.resolveDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    LocalDataSource.prototype.resolveDataProvider = function () {
        var provider_ = new DataSourceLocalDataProvider();
        provider_.executionContext = new DataSourceExecutionContext();
        return provider_;
    };
    LocalDataSource.prototype.propertyUpdatedOverride = function (a, b, c) {
        _super.prototype.propertyUpdatedOverride.call(this, a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                break;
            case "ActualDataProvider":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
            case "ItemsSource":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
        }
    };
    LocalDataSource.prototype.getItemAtIndex = function (a) {
        if (this.ca != null && this.ca.ak != null) {
            return this.ca.ak.item(a);
        }
        else {
            return this.actualDataProvider.getItemAtIndex(a);
        }
    };
    LocalDataSource.prototype.getItemPropertyAtIndex = function (a, b) {
        var c;
        if (this.ca != null) {
            c = this.ca.ak.item(a);
        }
        else {
            c = this.actualDataProvider.getItemAtIndex(a);
        }
        var item_ = c;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return this.getSpecialRowItemValue(c, b);
        }
        return this.actualDataProvider.getItemValue(c, b);
    };
    LocalDataSource.prototype.b5 = function () {
        return this.actualDataProvider;
    };
    LocalDataSource.prototype.cf = function () {
        return this.cl != null && this.cl.count > 0;
    };
    LocalDataSource.prototype.refreshInternalOverride = function () {
        _super.prototype.refreshInternalOverride.call(this);
        if (this.actualDataProvider != null) {
            if (this.cg() || this.ch() || this.ci() || this.cf()) {
                if (this.ca == null) {
                    if (this.cc == null) {
                        this.cc = new LocalDataSourceViewUpdateNotifier(this);
                    }
                    this.ca = new RearrangedListView(this.actualDataProvider);
                    this.ca.n = this.cc;
                }
                this.ensureComparables(this.actualDataProvider.actualSchema);
                this.ca.z = this.shouldEmitSectionHeaders && this.ad;
                this.ca.y = this.shouldEmitSectionFooters && this.ad;
                this.ca.aa = this.shouldEmitShiftedRows;
                this.ca.ba(this.cl);
                this.ca.ag = this.ck();
                this.ca.af = this.cj();
                this.ca.g = this.b9();
                this.ca.o = this.groupDescriptions;
                this.ca.p = this.sortDescriptions;
                this.ca.d = this;
                this.ca.v = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                this.ca.i = this.cb();
                this.ca.a6();
                this.actualSchema = this.actualDataProvider.actualSchema;
                this.actualCount = this.ca.ak.count;
            }
            else {
                var a = this.b5();
                this.actualSchema = this.actualDataProvider.actualSchema;
                if (a != null) {
                    this.actualCount = a.actualCount;
                }
                else {
                    this.actualCount = 0;
                }
                if (this.ca != null) {
                    this.ca.n = null;
                    this.ca = null;
                    this.onBroadcastClearItems();
                }
            }
        }
        else {
            this.actualCount = 0;
            this.actualSchema = null;
        }
    };
    LocalDataSource.prototype.get_isItemIndexLookupSupported = function () {
        return true;
    };
    LocalDataSource.prototype.get_isKeyIndexLookupSupported = function () {
        return true;
    };
    LocalDataSource.prototype.indexOfItem = function (a) {
        if (this.ca != null) {
            return this.ca.ak.indexOf(a);
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        if (this.actualDataProvider != null) {
            var b = this.actualDataProvider.actualCount;
            var c = void 0;
            for (var d = 0; d < b; d++) {
                c = this.actualDataProvider.getItemAtIndex(d);
                if (this.ce(c, a)) {
                    return d;
                }
            }
        }
        return -1;
    };
    LocalDataSource.prototype.ce = function (a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    };
    LocalDataSource.prototype.indexOfKey = function (a) {
        var b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return this.indexOfItem(a[0]);
        }
        var c = this.b9();
        var d;
        if (this.ca != null) {
            var e = this.ca.ak.count;
            for (var f = 0; f < e; f++) {
                d = this.ca.ak.item(f);
                if (!(typeCast(DataSourceSpecialRow.$, d) !== null) && c.i(d, a) == 0) {
                    return f;
                }
            }
            return -1;
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        if (this.actualDataProvider != null) {
            var g = this.actualDataProvider.actualCount;
            for (var h = 0; h < g; h++) {
                d = this.actualDataProvider.getItemAtIndex(h);
                if (c.i(d, a) == 0) {
                    return h;
                }
            }
        }
        return -1;
    };
    LocalDataSource.prototype.onActualPrimaryKeyChangedOverrride = function (a, b) {
        _super.prototype.onActualPrimaryKeyChangedOverrride.call(this, a, b);
        this.b8 = null;
    };
    LocalDataSource.prototype.b9 = function () {
        if (this.b8 != null) {
            return this.b8;
        }
        if (this.actualPrimaryKey == null) {
            this.b8 = new DataSourcePropertiesComparer(null, null, null, this);
            return this.b8;
        }
        var a = new Array(this.actualPrimaryKey.length);
        for (var b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        this.b8 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
        return this.b8;
    };
    LocalDataSource.prototype.cb = function () {
        if (this.filterExpressions.j.count == 0) {
            return null;
        }
        var a = this.actualDataProvider;
        var b = this.actualDataProvider.actualSchema;
        var c = this.filterExpressions.j;
        var d = function (e) {
            for (var f = 0; f < c.count; f++) {
                if (!c.item(f).match(e, a, b)) {
                    return false;
                }
            }
            return true;
        };
        return d;
    };
    LocalDataSource.prototype.ck = function () {
        var a = 0;
        if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
            return null;
        }
        a = this.sortDescriptions.k.count;
        if (this.groupDescriptions != null) {
            a += this.groupDescriptions.k.count;
        }
        var b = new Array(a);
        var c = new Array(a);
        var d = 0;
        if (this.groupDescriptions != null) {
            for (var e = 0; e < this.groupDescriptions.k.count; e++) {
                b[e] = this.groupDescriptions.k.item(e).propertyName;
                c[e] = this.groupDescriptions.k.item(e).direction;
                d++;
            }
        }
        for (var f = 0; f < this.sortDescriptions.k.count; f++) {
            b[f + d] = this.sortDescriptions.k.item(f).propertyName;
            c[f + d] = this.sortDescriptions.k.item(f).direction;
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    };
    LocalDataSource.prototype.cj = function () {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return null;
        }
        var a = 0;
        a = this.groupDescriptions.k.count;
        var b = new Array(a);
        var c = new Array(a);
        if (this.groupDescriptions != null) {
            for (var d = 0; d < this.groupDescriptions.k.count; d++) {
                b[d] = this.groupDescriptions.k.item(d).propertyName;
                c[d] = this.groupDescriptions.k.item(d).direction;
            }
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    };
    LocalDataSource.prototype.ch = function () {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isGroupingSupported) {
            return false;
        }
        return true;
    };
    LocalDataSource.prototype.ci = function () {
        if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isSortingSupported) {
            return false;
        }
        return true;
    };
    LocalDataSource.prototype.cg = function () {
        return this.filterExpressions != null && this.filterExpressions.j.count > 0;
    };
    LocalDataSource.prototype.onClearItemsOverride = function () {
        if (this.ca != null) {
            this.ca.notifyClearItems();
            this.queueAutoRefresh();
        }
        else {
            _super.prototype.onClearItemsOverride.call(this);
        }
    };
    LocalDataSource.prototype.onSetItemOverride = function (a, b, c) {
        if (this.ca != null) {
            this.ca.notifySetItem(a, b, c);
        }
        else {
            _super.prototype.onSetItemOverride.call(this, a, b, c);
        }
    };
    LocalDataSource.prototype.onInsertItemOverride = function (a, b) {
        if (this.ca != null) {
            this.ca.notifyInsertItem(a, b);
        }
        else {
            _super.prototype.onInsertItemOverride.call(this, a, b);
        }
    };
    LocalDataSource.prototype.onRemoveItemOverride = function (a, b) {
        if (this.ca != null) {
            this.ca.notifyRemoveItem(a, b);
        }
        else {
            _super.prototype.onRemoveItemOverride.call(this, a, b);
        }
    };
    LocalDataSource.prototype.cz = function () {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastClearItems();
    };
    LocalDataSource.prototype.c2 = function (a, b, c) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastSetItem(a, b, c);
    };
    LocalDataSource.prototype.c0 = function (a, b) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastInsertItem(a, b);
    };
    LocalDataSource.prototype.c1 = function (a, b) {
        this.actualCount = this.ca.ak.count;
        this.onBroadcastRemoveItem(a, b);
    };
    LocalDataSource.prototype.pinRow = function (a) {
        _super.prototype.pinRow.call(this, a);
        this.cq = -1;
        this.cm = -1;
        if (this.ca != null) {
            this.cl.add(a);
            this.ca.a5(a);
        }
        else {
            this.cl.add(a);
            this.queueAutoRefresh();
        }
    };
    LocalDataSource.prototype.unpinRow = function (a) {
        _super.prototype.unpinRow.call(this, a);
        var b = this.b9();
        if (this.ca != null) {
            for (var c = this.cl.count - 1; c >= 0; c--) {
                var d = this.cl._inner[c];
                if (d.length != a.length) {
                    continue;
                }
                if (b.h(d, a) == 0) {
                    this.cl.removeAt(c);
                    this.ca.bc(d);
                }
            }
        }
        else {
            for (var e = this.cl.count - 1; e >= 0; e--) {
                var f = this.cl._inner[e];
                if (f.length != a.length) {
                    continue;
                }
                if (b.h(f, a) == 0) {
                    this.cl.removeAt(e);
                }
            }
            this.queueAutoRefresh();
        }
        this.cq = -1;
        this.cm = -1;
    };
    LocalDataSource.prototype.clearPinnedRows = function () {
        for (var a = this.cl.count - 1; a >= 0; a--) {
            this.unpinRow(this.cl._inner[a]);
        }
    };
    LocalDataSource.prototype.isRowPinned = function (a) {
        if (this.ca == null) {
            return false;
        }
        var b = this.getItemAtIndex(a);
        if (b == null) {
            return false;
        }
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            if (item_.rowType == 3) {
                return true;
            }
        }
        var c = this.b9();
        var d;
        if (this.actualPrimaryKey == null) {
            d = new Array(1);
            d[0] = b;
        }
        else {
            var e = this.actualPrimaryKey;
            var f = e.length;
            d = new Array(f);
            for (var g = 0; g < f; g++) {
                d[g] = this.getItemProperty(b, e[g]);
            }
        }
        for (var h = 0; h < this.cl.count; h++) {
            if (c.h(this.cl._inner[h], d) == 0) {
                return true;
            }
        }
        return false;
    };
    LocalDataSource.prototype.get_isSortingSupported = function () {
        if (this.n != null && !this.cd) {
            this.cd = true;
            var a = this.n.isSortingSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.get_isFilteringSupported = function () {
        if (this.n != null && !this.cd) {
            this.cd = true;
            var a = this.n.isFilteringSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.get_isGroupingSupported = function () {
        if (this.n != null && !this.cd) {
            this.cd = true;
            var a = this.n.isGroupingSupportedOverride;
            this.cd = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.getStickyRowPriority = function (a) {
        if (this.getRowType(a) == 1 || this.getRowType(a) == 2) {
            return 100 - this.getRowLevel(a);
        }
        else if (this.getRowType(a) == 3) {
            return 2;
        }
        return 1;
    };
    LocalDataSource.prototype.getStickyRowsInRange = function (a, b) {
        if (this.ca == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && !this.cf())) {
            return null;
        }
        var c = null;
        var d = null;
        if (this.ca.aj.count == 1) {
            c = this.ca.aj._inner[0];
            d = this.ca.aj._inner[0];
        }
        else {
            c = this.ca.k(a);
            d = this.ca.k(b);
        }
        if (c == null || d == null) {
            return null;
        }
        if (c.l == this.cq && c.g == this.cs && c.m == this.ct && c.k == this.cr && d.l == this.cm && d.g == this.co && d.m == this.cp && d.k == this.cn) {
            return this.bz;
        }
        this.cq = c.l;
        this.cm = d.l;
        this.cs = c.g;
        this.co = d.g;
        this.ct = c.m;
        this.cp = d.m;
        this.cr = c.k;
        this.cn = d.k;
        if (this.ca.aj.count == 1) {
            this.cm = d.k;
        }
        var e = 0;
        if (this.shouldEmitSectionHeaders && this.ad) {
            e = 1;
        }
        var f = new List$1(Number_$type, 0);
        for (var g = c.l; g <= d.l; g++) {
            if (this.shouldEmitSectionHeaders && this.ad) {
                for (var h = 0; h < this.ca.aj._inner[g].b.length; h++) {
                    f.add(this.ca.aj._inner[g].m + h);
                    if (!this.ca.aj._inner[g].b[h]) {
                        break;
                    }
                }
            }
            if (this.shouldEmitShiftedRows) {
                var i = this.ca.aj._inner[g].b.length;
                for (var j = 0; j < this.ca.aj._inner[g].g; j++) {
                    f.add(this.ca.aj._inner[g].m + j + i);
                }
            }
            if (this.shouldEmitSectionFooters && this.ad) {
                for (var k = this.ca.aj._inner[g].b.length - 1; k >= 0; k--) {
                    if (!this.ca.aj._inner[g].b[k]) {
                        break;
                    }
                    f.add(this.ca.aj._inner[g].k - k);
                }
            }
        }
        this.bz = f.toArray();
        return this.bz;
    };
    LocalDataSource.prototype.isExclusivelySticky = function (a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    };
    LocalDataSource.prototype.getRowType = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    };
    LocalDataSource.prototype.setIsRowExpandedAtIndex = function (a, b) {
        if (this.isSectionCollapsable && this.ca != null && this.ca.ak.count > 0 && this.ca.ak.count > a) {
            this.ca.a9(a, b);
        }
    };
    LocalDataSource.prototype.getIsRowExpandedAtIndex = function (a) {
        if (this.ca != null && this.ca.ak.count > 0 && this.ca.ak.count > a) {
            return this.ca.t(a);
        }
        return true;
    };
    LocalDataSource.prototype.getRowLevel = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        return 0;
    };
    LocalDataSource.$t = markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
}(BaseDataSource));
export { LocalDataSource };
/**
 * @hidden
 */
var LocalDataSourceViewUpdateNotifier = /** @class */ (function (_super) {
    tslib_1.__extends(LocalDataSourceViewUpdateNotifier, _super);
    function LocalDataSourceViewUpdateNotifier(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    LocalDataSourceViewUpdateNotifier.prototype.notifyClearItems = function () {
        this.a.cz();
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifyInsertItem = function (a, b) {
        this.a.c0(a, b);
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifyRemoveItem = function (a, b) {
        this.a.c1(a, b);
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifySetItem = function (a, b, c) {
        this.a.c2(a, b, c);
    };
    LocalDataSourceViewUpdateNotifier.$t = markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
}(Base));
export { LocalDataSourceViewUpdateNotifier };
