import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceVirtualDataProvider } from "./IDataSourceVirtualDataProvider";
import { IExternalVirtualDataSource } from "./IExternalVirtualDataSource";
import { Type } from "./type";
import { DataSourcePageRequestPriority } from "./DataSourcePageRequestPriority";
import { DataSourceRowType } from "./DataSourceRowType";
/**
 * @hidden
 */
export declare class VirtualDataSource extends BaseDataSource implements IPageCandidatesSink {
    static $t: Type;
    constructor();
    private b1;
    private ch;
    protected cb: PagePredictionEngine;
    protected get_actualBaseDataProvider(): IDataSourceDataProvider;
    protected readonly actualBaseDataProvider: IDataSourceDataProvider;
    private b4;
    dataProvider: IDataSourceVirtualDataProvider;
    private b3;
    actualDataProvider: IDataSourceVirtualDataProvider;
    private cx;
    pageSizeRequested: number;
    protected resetCache(): void;
    protected resetCacheOverride(): void;
    private cw;
    maxCachedPages: number;
    protected actualPageSizePopulated: boolean;
    private cn;
    actualPageSize: number;
    private cf;
    protected get_isSortingSupported(): boolean;
    protected get_isFilteringSupported(): boolean;
    protected get_isGroupingSupported(): boolean;
    private b8;
    b9: IExternalVirtualDataSource;
    protected resolveDataProvider(): IDataSourceVirtualDataProvider;
    protected propertyUpdatedOverride(a: string, b: any, c: any): void;
    private c0;
    private dd;
    private dj;
    protected resolveFullCount(a: number): number;
    private di;
    private dh;
    private cz;
    private df;
    protected get_isVirtual(): boolean;
    private ce;
    private cl;
    private cm;
    private cg;
    private bz;
    isPlaceholderItem(a: number): boolean;
    getItemAtIndex(a: number): any;
    private c4;
    private b2;
    private cd;
    private cc;
    getItemPropertyAtIndex(a: number, b: string): any;
    private c5;
    private dg;
    private de;
    addCandidate(a: number, b: DataSourcePageRequestPriority): boolean;
    removeCandidate(a: number): void;
    transformPage(a: number): number[];
    getUnrealizedCount(): number;
    onSetItemOverride(a: number, b: any, c: any): void;
    protected refreshInternalOverride(): void;
    private dk;
    onClearItemsOverride(): void;
    onInsertItemOverride(a: number, b: any): void;
    onRemoveItemOverride(a: number, b: any): void;
    protected get_isItemIndexLookupSupported(): boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    indexOfItem(a: any): number;
    private cj;
    indexOfKey(a: any[]): number;
    private ca;
    getStickyRowPriority(a: number): number;
    unpinRow(a: any[]): void;
    pinRow(a: any[]): void;
    isRowPinned(a: number): boolean;
    private b0;
    private cs;
    private co;
    private cu;
    private cq;
    private cv;
    private cr;
    private ct;
    private cp;
    getStickyRowsInRange(a: number, b: number): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    private ck;
    getIsRowExpandedAtIndex(a: number): boolean;
    setIsRowExpandedAtIndex(a: number, b: boolean): void;
    getRowLevel(a: number): number;
    private c8;
    private c9;
}
