/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
var VirtualDataSource = /** @class */ (function (_super) {
    tslib_1.__extends(VirtualDataSource, _super);
    function VirtualDataSource() {
        var _this = _super.call(this) || this;
        _this.b1 = null;
        _this.ch = false;
        _this.cb = null;
        _this.b4 = null;
        _this.b3 = null;
        _this.cx = 50;
        _this.cw = 200;
        _this.actualPageSizePopulated = false;
        _this.cn = 50;
        _this.cf = false;
        _this.b8 = null;
        _this.ce = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
        _this.cl = new Dictionary$2(Base.$, Array_$type, 0);
        _this.cm = new Dictionary$2(Number_$type, Number_$type, 0);
        _this.cg = false;
        _this.bz = null;
        _this.cd = new SectionMap();
        _this.b0 = null;
        _this.cs = -1;
        _this.co = -1;
        _this.cu = -1;
        _this.cq = -1;
        _this.cv = -1;
        _this.cr = -1;
        _this.ct = -1;
        _this.cp = -1;
        _this.ck = new Dictionary$2(String_$type, Boolean_$type, 0);
        _this.cb = new PagePredictionEngine();
        _this.cb.e = _this;
        _this.cb.ag = _this.actualPageSize;
        _this.cb.f = _this.cd;
        _this.executionContext = new DataSourceExecutionContext();
        _this.cb.b = _this.executionContext;
        return _this;
    }
    VirtualDataSource.prototype.get_actualBaseDataProvider = function () {
        return this.actualDataProvider;
    };
    Object.defineProperty(VirtualDataSource.prototype, "actualBaseDataProvider", {
        get: function () {
            return this.get_actualBaseDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "dataProvider", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.onPropertyUpdated("DataProvider", b, this.b4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualDataProvider", {
        get: function () {
            if (this.b3 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.onPropertyUpdated("ActualDataProvider", b, this.b3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "pageSizeRequested", {
        get: function () {
            return this.cx;
        },
        set: function (a) {
            var b = this.cx;
            this.cx = a;
            if (b != this.cx) {
                this.onPropertyUpdated("PageSizeRequested", b, this.cx);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resetCache = function () {
        if (this.b9 != null) {
            this.b9.resetCache();
        }
        this.resetCacheOverride();
    };
    VirtualDataSource.prototype.resetCacheOverride = function () {
        this.ce.i();
    };
    Object.defineProperty(VirtualDataSource.prototype, "maxCachedPages", {
        get: function () {
            return this.cw;
        },
        set: function (a) {
            var b = this.cw;
            this.cw = a;
            if (b != this.cw) {
                this.onPropertyUpdated("MaxCachedPages", b, this.cw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualPageSize", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.onPropertyUpdated("ActualPageSize", b, this.cn);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.get_isSortingSupported = function () {
        if (this.n != null && !this.cf) {
            this.cf = true;
            var a = this.n.isSortingSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isFilteringSupported = function () {
        if (this.n != null && !this.cf) {
            this.cf = true;
            var a = this.n.isFilteringSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isGroupingSupported = function () {
        if (this.n != null && !this.cf) {
            this.cf = true;
            var a = this.n.isGroupingSupportedOverride;
            this.cf = false;
            return a;
        }
        return false;
    };
    Object.defineProperty(VirtualDataSource.prototype, "b9", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            this.b8 = a;
            this.actualDataProvider = this.resolveDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resolveDataProvider = function () {
        if (this.b9 == null) {
            return null;
        }
        return this.b9.resolveDataProvider();
    };
    VirtualDataSource.prototype.propertyUpdatedOverride = function (a, b, c) {
        _super.prototype.propertyUpdatedOverride.call(this, a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                this.queueAutoRefresh();
                break;
            case "ExecutionContext":
                this.cb.b = this.executionContext;
                break;
            case "ActualDataProvider":
                this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                this.actualDataProvider.pageLoaded = runOn(this, this.dd);
                this.queueAutoRefresh();
                break;
            case "PageSizeRequested":
                this.actualPageSize = this.pageSizeRequested;
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                }
                this.queueAutoRefresh();
                break;
            case "ActualPageSize":
                this.cb.ag = this.actualPageSize;
                this.queueAutoRefresh();
                break;
            case "FirstVisibleIndexRequested":
                this.cb.aa = this.firstVisibleIndexRequested;
                break;
            case "LastVisibleIndexRequested":
                this.cb.ae = this.lastVisibleIndexRequested;
                break;
            case "ActualCount":
                if (this.actualDataProvider != null && !this.cd.n) {
                    this.cb.ab = this.actualDataProvider.actualCount;
                }
                else {
                    this.cb.ab = this.actualCount;
                }
                this.queueAutoRefresh();
                break;
            case "MaxCachedPages":
                this.ce.h = this.maxCachedPages;
                break;
        }
    };
    VirtualDataSource.prototype.c0 = function (a) {
        if (this.ad && this.cd.n) {
            var b = this.cc(a);
            if (b == null) {
                b = this.cd.c();
            }
            return a - b.f;
        }
        return a;
    };
    VirtualDataSource.prototype.dd = function (a, b, c) {
        var _this = this;
        var d = this.executionContext;
        if (d != null) {
            d.execute(function () { return _this.dj(a, b, c); });
        }
        else {
            this.dj(a, b, c);
        }
    };
    VirtualDataSource.prototype.dj = function (a, b, c) {
        if (a == null) {
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            return;
        }
        if (c != this.actualPageSize && !this.actualPageSizePopulated) {
            this.actualPageSize = c;
        }
        this.actualPageSizePopulated = true;
        var d = a.pageIndex();
        this.de(d);
        this.ce.item(d, a);
        var e = a.schema();
        if (e != null) {
            this.actualSchema = e;
        }
        var f = a.getGroupInformation();
        if (this.bz == null && f != null) {
            this.bz = f;
            this.di();
            this.ch = false;
        }
        b = this.resolveFullCount(b);
        if (this.actualCount != b) {
            this.actualCount = b;
        }
        this.dh(a);
    };
    VirtualDataSource.prototype.resolveFullCount = function (a) {
        if (this.bz != null) {
            return this.cd.q;
        }
        return a;
    };
    VirtualDataSource.prototype.di = function () {
        var a = 0;
        var b = 0;
        var c = 0;
        if (this.shouldEmitSectionHeaders) {
            switch (this.sectionHeaderDisplayMode) {
                case 0:
                    c++;
                    break;
                case 1:
                    c += this.groupDescriptions.k.count;
                    break;
            }
        }
        if (this.shouldEmitSectionFooters) {
            c++;
        }
        var d = this.shouldEmitSectionHeaders;
        var e = this.shouldEmitSectionFooters;
        for (var f = 0; f < this.bz.length; f++) {
            var g = new SectionData();
            if (d) {
                switch (this.sectionHeaderDisplayMode) {
                    case 0:
                        b++;
                        break;
                    case 1:
                        b += this.groupDescriptions.k.count;
                        break;
                }
            }
            var h = this.bz[f].endIndex - this.bz[f].startIndex;
            g.m = a;
            g.l = f;
            g.j = h + 1;
            g.k = a + h;
            g.k += c;
            g.f = b;
            g.c = this.bz[f].groupKeyProperties;
            g.d = this.bz[f].groupKeyValues;
            g.n(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
            if (e) {
                b++;
            }
            for (var i = 0; i < g.b.length; i++) {
                var j = this.c9(g, i);
                g.a[i] = j;
                if (this.ck.containsKey(j)) {
                    g.b[i] = this.ck.item(j);
                }
                else {
                    g.b[i] = this.isSectionExpandedDefault;
                }
                if (!g.b[i]) {
                    var k = g.b.length - 1 - i;
                    g.k -= k;
                    b -= k;
                    if (e) {
                        b--;
                    }
                    i += k;
                }
            }
            if (!g.e) {
                g.k -= g.j;
                b -= g.j;
            }
            a = g.k + 1;
            this.cd.p.add(g);
        }
    };
    VirtualDataSource.prototype.dh = function (a) {
        if (this.updateNotifier != null) {
            var b = a.pageIndex() * this.actualPageSize;
            if (this.actualDataProvider != null) {
                if (b > this.actualDataProvider.actualCount) {
                    return;
                }
            }
            var c = this.cz(b);
            var d = this.cz(b + a.count() - 1);
            if (c > 0 && this.getRowType(c - 1) == 1) {
                c--;
            }
            if (this.actualCount == 0 && a.count() == 0) {
                this.onClearItems();
            }
            else {
                this.updateNotifier.rangeActualized(c, d);
            }
        }
    };
    VirtualDataSource.prototype.cz = function (a) {
        if (this.ad && this.cd.n) {
            var b = this.cd.f(a);
            if (b == null) {
                b = this.cd.c();
            }
            if (!b.e) {
                return b.m;
            }
            return a + b.f;
        }
        return a;
    };
    VirtualDataSource.prototype.df = function (a) {
        a();
    };
    VirtualDataSource.prototype.get_isVirtual = function () {
        return true;
    };
    VirtualDataSource.prototype.isPlaceholderItem = function (a) {
        var b = this.b2(a);
        var c = b[0];
        if (!this.ce.d(c)) {
            return true;
        }
        return false;
    };
    VirtualDataSource.prototype.getItemAtIndex = function (a) {
        var b = this.b2(a);
        var c = b[0];
        if (!this.ce.d(c)) {
            if (b[1] == -1) {
                return this.c4(a);
            }
            return null;
        }
        var d = this.ce.item(c);
        var e = b[1];
        if (e == -1) {
            return this.c4(a);
        }
        return d.getItemAtIndex(e);
    };
    VirtualDataSource.prototype.c4 = function (a) {
        var b = this.cc(a);
        if (a >= b.m && a < b.m + b.b.length) {
            var c = a - b.m;
            var d = new DataSourceSpecialRow();
            d.rowType = 1;
            d.level = c;
            if (this.sectionHeaderDisplayMode == 0) {
                for (var e = 0; e < this.groupDescriptions.k.count; e++) {
                    d.setSectionValue(this.groupDescriptions.k.item(e).propertyName, b.d[e]);
                }
            }
            else {
                d.setSectionValue(this.groupDescriptions.k.item(c).propertyName, b.d[c]);
            }
            return d;
        }
        if (a == b.k) {
            var f = new DataSourceSpecialRow();
            f.rowType = 2;
            for (var g = 0; g < this.groupDescriptions.k.count; g++) {
                f.setSectionValue(this.groupDescriptions.k.item(g).propertyName, b.d[g]);
            }
            return f;
        }
        return null;
    };
    VirtualDataSource.prototype.b2 = function (a) {
        if (this.ad && this.cd.n) {
            var b = this.cc(a);
            if (b == null) {
                b = this.cd.c();
            }
            var c = b.m;
            var d = false;
            if (a >= c && a < c + b.b.length && this.shouldEmitSectionHeaders) {
                d = true;
            }
            if (a - (c + b.b.length - 1) <= b.g) {
                d = true;
            }
            var e = a - b.f;
            var f = truncate(Math.floor(e / this.actualPageSize));
            var g = e % this.actualPageSize;
            if (d) {
                g = -1;
            }
            var h = new Array(2);
            h[0] = f;
            h[1] = g;
            return h;
        }
        else {
            var i = truncate(Math.floor(a / this.actualPageSize));
            var j = a % this.actualPageSize;
            var k = new Array(2);
            k[0] = i;
            k[1] = j;
            return k;
        }
    };
    VirtualDataSource.prototype.cc = function (a) {
        return this.cd.d(a);
    };
    VirtualDataSource.prototype.getItemPropertyAtIndex = function (a, b) {
        var c = this.b2(a);
        var d = c[0];
        if (!this.ce.d(d)) {
            if (c[1] == -1) {
                return this.c5(a, b);
            }
            return null;
        }
        var e = this.ce.item(d);
        var f = c[1];
        if (f == -1) {
            return this.c5(a, b);
        }
        return e.getItemValueAtIndex(f, b);
    };
    VirtualDataSource.prototype.c5 = function (a, b) {
        var c = this.c4(a);
        if (typeCast(DataSourceSpecialRow.$, c) !== null) {
            return c.getValue(b);
        }
        return null;
    };
    VirtualDataSource.prototype.dg = function (a) {
        if (!this.cm.containsKey(a)) {
            this.cm.addItem(a, 1);
        }
        else {
            this.cm.item(a, this.cm.item(a) + 1);
        }
    };
    VirtualDataSource.prototype.de = function (a) {
        if (this.cm.containsKey(a)) {
            this.cm.item(a, this.cm.item(a) - 1);
            if (this.cm.item(a) <= 0) {
                this.cm.removeItem(a);
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.removePageRequest(a);
                }
            }
        }
    };
    VirtualDataSource.prototype.addCandidate = function (a, b) {
        var c = false;
        if (!this.cl.containsKey(a)) {
            var d = new List$1(Number_$type, 0);
            var e = this.transformPage(a);
            for (var f = 0; f < e.length; f++) {
                var g = e[f];
                if (!this.ce.d(g)) {
                    d.add(g);
                    this.dg(g);
                    var h = this.cm.item(g);
                    if (h == 1 && this.actualDataProvider != null) {
                        this.actualDataProvider.addPageRequest(g, b);
                    }
                    c = true;
                }
            }
            if (d.count > 0) {
                this.cl.addItem(a, d.toArray());
            }
        }
        return c;
    };
    VirtualDataSource.prototype.removeCandidate = function (a) {
        if (this.cl.containsKey(a)) {
            for (var b = 0; b < this.cl.item(a).length; b++) {
                var c = this.cl.item(a)[b];
                this.de(c);
            }
            this.cl.removeItem(a);
        }
    };
    VirtualDataSource.prototype.transformPage = function (a) {
        var b = [a];
        if (this.ad && this.cd.n) {
            var c = a * this.actualPageSize;
            var d = c + this.actualPageSize - 1;
            var e = this.cc(c);
            var f = new List$1(Number_$type, 0);
            for (var g = c; g <= d; g++) {
                if (e == null) {
                    break;
                }
                if (g > e.k) {
                    if (e.l < this.cd.p.count - 1) {
                        e = this.cd.p._inner[e.l + 1];
                    }
                    else {
                        break;
                    }
                }
                if (!e.e || (g >= e.m && g <= e.m + (e.b.length - 1) + e.g)) {
                    continue;
                }
                var h = g - e.f;
                var i = intDivide(h, this.actualPageSize);
                if (!f.contains(i)) {
                    f.add(i);
                }
            }
            b = f.toArray();
        }
        return b;
    };
    VirtualDataSource.prototype.getUnrealizedCount = function () {
        var a = this.ce.g * this.actualPageSize;
        var b = this.actualCount - a;
        return b;
    };
    VirtualDataSource.prototype.onSetItemOverride = function (a, b, c) {
        _super.prototype.onSetItemOverride.call(this, a, b, c);
        var d = this.b2(a);
        var e = d[0];
        if (this.ce.d(e)) {
            this.ce.j(e);
        }
    };
    VirtualDataSource.prototype.refreshInternalOverride = function () {
        _super.prototype.refreshInternalOverride.call(this);
        this.actualPageSizePopulated = false;
        var a = this.actualCount != 0;
        this.cg = true;
        if (!this.ch) {
            this.resetCache();
            if (a) {
                this.onClearItems();
            }
            this.bz = null;
            this.cd.r();
        }
        else {
            this.ch = false;
            if (a) {
                this.onClearItems();
            }
        }
        this.dk();
        this.cb.au();
        this.cg = false;
    };
    VirtualDataSource.prototype.dk = function () {
        var e_1, _a;
        if (this.actualDataProvider != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.cl.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    for (var c = 0; c < a.length; c++) {
                        var b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    VirtualDataSource.prototype.onClearItemsOverride = function () {
        _super.prototype.onClearItemsOverride.call(this);
        if (!this.cg) {
            this.queueAutoRefresh();
        }
    };
    VirtualDataSource.prototype.onInsertItemOverride = function (a, b) {
        _super.prototype.onInsertItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.onRemoveItemOverride = function (a, b) {
        _super.prototype.onRemoveItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.get_isItemIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.get_isKeyIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.indexOfItem = function (a) {
        var b = this.ce.b;
        var c = b.o;
        var d = b.q;
        var e = d.count;
        var f = b.p;
        for (var g = 0; g < e; g++) {
            if (f._inner[g]) {
                continue;
            }
            var h = d._inner[g].b;
            var i = h.count();
            for (var j = 0; j < i; j++) {
                if (this.cj(h.getItemAtIndex(j), a)) {
                    var k = typeGetValue(c._inner[g]);
                    var l = k * this.actualPageSize;
                    return l + j;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.cj = function (a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    };
    VirtualDataSource.prototype.indexOfKey = function (a) {
        var b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return -1;
        }
        this.ensureComparables(this.actualSchema);
        var c = this.ca();
        var d = this.ce.b;
        var e = d.o;
        var f = d.q;
        var g = f.count;
        var h = d.p;
        for (var i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            var j = f._inner[i].b;
            var k = j.count();
            for (var l = 0; l < k; l++) {
                if (c.i(j.getItemAtIndex(l), a) == 0) {
                    var m = typeGetValue(e._inner[i]);
                    var n = m * this.actualPageSize;
                    return n + l;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.ca = function () {
        var a = new Array(this.actualPrimaryKey.length);
        for (var b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.b1, this);
    };
    VirtualDataSource.prototype.getStickyRowPriority = function (a) {
        if (this.getRowType(a) == 1 || this.getRowType(a) == 2) {
            return 100 - this.getRowLevel(a);
        }
        else if (this.getRowType(a) == 3) {
            return 2;
        }
        return 1;
    };
    VirtualDataSource.prototype.unpinRow = function (a) {
        _super.prototype.unpinRow.call(this, a);
    };
    VirtualDataSource.prototype.pinRow = function (a) {
        _super.prototype.pinRow.call(this, a);
    };
    VirtualDataSource.prototype.isRowPinned = function (a) {
        return _super.prototype.isRowPinned.call(this, a);
    };
    VirtualDataSource.prototype.getStickyRowsInRange = function (a, b) {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count == 0) {
            return null;
        }
        var c = this.cc(a);
        var d = this.cc(b);
        if (c == null || d == null) {
            return null;
        }
        if (c.l == this.cs && c.g == this.cu && c.m == this.cv && c.k == this.ct && d.l == this.co && d.g == this.cq && d.m == this.cr && d.k == this.cp) {
            return this.b0;
        }
        this.cs = c.l;
        this.co = d.l;
        this.cu = c.g;
        this.cq = d.g;
        this.cv = c.m;
        this.cr = d.m;
        this.ct = c.k;
        this.cp = d.k;
        var e = new List$1(Number_$type, 0);
        for (var f = c.l; f <= d.l; f++) {
            var g = this.cd.p._inner[f];
            if (this.shouldEmitSectionHeaders && this.ad) {
                for (var h = 0; h < g.b.length; h++) {
                    e.add(g.m + h);
                    if (!g.b[h]) {
                        break;
                    }
                }
            }
            if (this.shouldEmitShiftedRows) {
                var i = g.b.length;
                for (var j = 0; j < g.g; j++) {
                    e.add(g.m + j + i);
                }
            }
            if (this.shouldEmitSectionFooters && this.ad) {
                for (var k = g.b.length - 1; k >= 0; k--) {
                    if (!g.b[k]) {
                        break;
                    }
                    e.add(g.k - k);
                }
            }
        }
        this.b0 = e.toArray();
        return this.b0;
    };
    VirtualDataSource.prototype.isExclusivelySticky = function (a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    };
    VirtualDataSource.prototype.getRowType = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    };
    VirtualDataSource.prototype.getIsRowExpandedAtIndex = function (a) {
        var b = this.cd.d(a);
        if (b == null) {
            b = this.cd.c();
        }
        for (var c = 0; c < b.b.length; c++) {
            if (a == b.m + c) {
                return b.b[c];
            }
        }
        return _super.prototype.getIsRowExpandedAtIndex.call(this, a);
    };
    VirtualDataSource.prototype.setIsRowExpandedAtIndex = function (a, b) {
        var c = this.cd.d(a);
        if (c == null) {
            c = this.cd.c();
        }
        for (var d = 0; d < c.b.length; d++) {
            if (a == c.m + d) {
                var e = false;
                var f = c.a[d];
                if (this.ck.containsKey(f) && this.ck.item(f) != b) {
                    if (b == this.isSectionExpandedDefault) {
                        this.ck.removeItem(f);
                    }
                    else {
                        this.ck.item(f, b);
                    }
                    e = true;
                }
                else if (b != this.isSectionExpandedDefault) {
                    this.ck.addItem(f, b);
                    e = true;
                }
                if (e) {
                    this.cd.r();
                    this.di();
                    this.ch = true;
                    this.actualCount = this.cd.q;
                }
                break;
            }
        }
    };
    VirtualDataSource.prototype.getRowLevel = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        return 0;
    };
    VirtualDataSource.prototype.c8 = function (a) {
        var b = "";
        for (var c = 0; c < a.c.length; c++) {
            b += a.c[c] + ":" + a.d[c];
        }
        return b;
    };
    VirtualDataSource.prototype.c9 = function (a, b) {
        if (this.sectionHeaderDisplayMode == 0) {
            return this.c8(a);
        }
        var c = "";
        for (var d = 0; d < a.c.length; d++) {
            c += a.c[d] + ":" + a.d[d] + ":";
        }
        c += b;
        return c;
    };
    VirtualDataSource.$t = markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
}(BaseDataSource));
export { VirtualDataSource };
